#include <stdlib.h>
#include <string.h>
#include "history.h"

char **buffer;

int top = 0;

int ini() {
   int i;
   buffer = malloc(sizeof(char*) *  HISTORY_LENGTH);
   for(i = 0;i<HISTORY_LENGTH; i++) {
      buffer[i] = NULL;
   }
   return 1;
}

/*
  add() returns -1 if the operation could not 
  be performed, 1 otherwise.
*/
int add(char *s) {
  int len;
  char *slot;
  len = strlen(s);
  slot = malloc((len+1)*sizeof(char)); 
  if (slot == NULL) {
    return -1;
  }
  if (buffer[top] != NULL) {
    free(buffer[top]);
  }
  buffer[top] = slot;
  strcpy(buffer[top], s);
  top = (top + 1) % HISTORY_LENGTH;
  return 1;
}

/*
  get() returns -1, if the history is empty. Otherwise, it copies the
  num'th last element to the area pointed to by the argument pointer and
  returns 1. This method also allocates the area, s points to.
  If num > HISTORY_LENGTH, then this method handles with num % HISTORY_LENGTH.
*/

int get(char **s, int num) { 
  int len;
  char *slot;
  num = (num-1) % HISTORY_LENGTH;
  num = (top + HISTORY_LENGTH - (num+1)) % HISTORY_LENGTH;
  slot = buffer[num];
  if (slot == NULL) {
    return -1;
  }
  len = strlen(slot);
  *s = malloc((len+1)*sizeof(char)); 
  if(*s == NULL) {
     return -1;
  }
  strcpy(*s, slot);
  return 1;
}
