#include <stdlib.h>
#include <string.h>
#include "stack.h"

char buffer[STACK_SIZE][LINE_LENGTH+1];
int top = 0;

/*
  push() returns -1 if the stack is full and the operation could not 
  be performed, 1 otherwise. Only the first LINE_LENGTH characters
  are accepted.
*/
int push(char *s) {
  int len;
  if (top == STACK_SIZE)
    return -1;
  len = strlen(s);
  if (len > LINE_LENGTH)
    len = LINE_LENGTH;
  strncpy(buffer[top], s, len);
  buffer[top][len] = 0;
  top++;
  return 1;
}

/*
  pop() returns -1, if the stack is empty. Otherwise, it copies the
  last element to the area pointed to by the argument pointer and
  returns 1.
*/
int pop(char *s) {
  if (top == 0)
    return -1;
  top--;
  strcpy(s, buffer[top]);
  return 1;
}
