#include <stdlib.h>
#include <string.h>
#include "stack.h"

char **buffer;

int top = 0;
int capacity = 0;

/*
  push() returns -1 if the stack is full and the operation could not 
  be performed, 1 otherwise. Only the first LINE_LENGTH characters
  are accepted.
*/
int push(char *s) {
  int len;
  char *slot;
  if(top == capacity){
    char **buf2;
    capacity = (capacity ? capacity*2 : 1);
    buf2 = realloc(buffer, capacity*sizeof(char*));
    if (buf2 == NULL)
      return -1;
    buffer = buf2;
  }
  len = strlen(s);
  slot = malloc((len+1)*sizeof(char)); 
  if (slot == NULL)
    return -1;
  buffer[top] = slot;
  strcpy(buffer[top], s);
  top++;
  return 1;
}

/*
  pop() returns -1, if the stack is empty. Otherwise, it copies the
  last element to the area pointed to by the argument pointer and
  returns 1.
*/

int pop(char *s) {
  if (top == 0)
    return -1;
  top--;
  strcpy(s, buffer[top]);
  free(buffer[top]);
  if(top <= (capacity)/4){
    char **buf2;
    capacity = capacity/2;
    buf2 = realloc(buffer, capacity*sizeof(char*));
    if (buf2 != NULL || capacity == 0)
      buffer = buf2;
  }
  return 1;
}
